 // Demo2Witty.ino 190306  3918b 99v
// welcome with Rainbow and fast blink push n times
// 1 push red several move on-off and back to menu
// 2 pushes green same with pfm speed changes
// 3 control blue with most TV IR 1pulse stop, 2,3,4,5 move
// 4 demonstrate log dim
// 5 compte
// 6 test accelero Gy521  reset to restart demo

 #include "Witty.h"
 #include "GetPush.h"
#define  Npix 8  // nombre de LEDs
#define  Brt 2 // max 31 brigtness 
#include "Apa102.h"
 #include "Telec.h"
  #include "Pfm.h"
  #include "Inter2.h"
#include "SerNum.h" 
 #define aadd 0x68*2 // a revoir
 #include "I2Ctwi.h"
 #include "Gy521.h"  
void setup() {                
  SetupWitty();
  SetupApa102();
  ApaClear ();
   SetupInter2(); 
  Cli(2); DelMs(500);  
}

// Une fonction démo à mettre dans un .h sépare avec par exemple un générateur de caractères
// On veut tester un compteur binaire 1 allumé 0 sombre
void ShowByte (uint8_t nn,uint8_t rr,uint8_t gg,uint8_t bb) {
  ApaHead();
  for (byte i=0; i<Npix; i++) {
    if (nn&0x80) {ApaLed(rr,gg,bb);}
    else {ApaLed(rr&3,gg&3,bb&3);}  // int modulo 1,2,3 
    nn<<=1;
  }
  ApaTail();  
}

byte cPush; 
byte cnt5=0;  // test 5
int16_t AcX,AcY,AcZ;
void loop() {
  cli();  // if Demo3 before
  ApaRainbow();  
  cPush= GetPush(); 
  switch (cPush) {
    case 1: // Demo1 Move
      ApaLogRed(4);
      #define D DelMs(1000)
      byte cmo;
      cmo=3;
      while(cmo--){  // on répète 3 fois   
        AvD; AvG; D;     // Avance
        StopG; StopD; D;    
        AvD;   D;         //TourneG
        StopG; StopD; D;
        AvG;  D;         // TourneD
        StopG; StopD; D; 
        RecD; RecG; D;  // Recule
        StopG; StopD; D; 
        AvD; AvG; D; RecD; RecG; D; 
        BlockG; BlockD; D;  
      }
      break;
    case 2: // Demo2 Pfm Move
      ApaLogBlue(10);
        SetupInter2();
        #define D2 delay(2000)  //DelMs(2000)
        pfmL=1; pfmR=1; D2;
        pfmL=-1; pfmR=-1; D2;  
        pfmL=4; pfmR=4; D2;
        pfmL=-4; pfmR=-4; D2;  
        pfmL=20; pfmR=20; D2;
        pfmL=0; pfmR=0; D2;
        pfmL=-20; pfmR=-20; D2; 
        pfmL=0; pfmR=0; D2;
        pfmL=70; pfmR=70; DelMs(500);
        pfmL=0; pfmR=0; D2;
        pfmL=-70; pfmR=-70; DelMs(500);
        pfmL=0; pfmR=0; D2;   
      ApaLogBlue(2); 
  #define Dac DelMs(50) 
  #define MaxVit 80  
  for (pfmR=0; pfmR<MaxVit; pfmR++) {pfmL=pfmR; Dac;}
        pfmL=0; pfmR=0; D2;
  for (pfmR=MaxVit; pfmR>0; pfmR--) {pfmL=pfmR; Dac;}
        pfmL=0; pfmR=0; D2;
  for (pfmR=0; pfmR>-MaxVit; pfmR--) {pfmL=pfmR; Dac;}
        pfmL=0; pfmR=0; D2;
  for (pfmR=-MaxVit; pfmR<0; pfmR++) {pfmL=pfmR; Dac;}
        pfmL=0; pfmR=0; D2;
      DelMs(1000);
      cli();
      break;    
    case 3: // Demo IRM control
      ApaLogWhite(10);
 byte nPress;
      while(1) {
        nPress= Compte();
        switch (nPress) {
          case 1:   // stop
            ApaLogGreen(10);
            FreeG; FreeD; break;
          case 2:   // avance
            ApaLogRed(10);
            AvG; AvD; break;
          case 3:   // tourneG
            ApaLogBlue(10);
            FreeG; AvD; break;
          case 4:   // tourneG
            ApaLogPink(10);         
            AvG; FreeD; break;
          case 5:   // recule
            ApaLogYellow(10);
            RecG; RecD; break;
          default: // plus de 5
            ShowByte (0x55,5,5,5); 
            FreeG; FreeD; break;
         }  // end switch
      }  // end while
    case 4: // RGB
       for (byte i=0;i<16;i++) {ApaLogRed(i); DelMs(100);}
       for (byte i=16;i>0;i--) {ApaLogRed(i-1); DelMs(100);}
       ApaLogGreen(1);DelMs(1000);ApaLogBlue(1);DelMs(1000);ApaLogRed(1);DelMs(1000);
       // add your own tricks
       break;
    case 5:
        while(1) {
          ShowByte (cnt5++,41,41,0);
          DelMs(200);
        }
      // reset to quit
 
      case 6: // Demo6 Gy521  click on terminal before
       ApaLogYellow(10);
       DelMs(2000);
       SetupI2Ctwi();
       SetupGy521();
       SetupSerNum();
       TerText("EnvoiSer Gy521"); TerCR();
       
       while(1){
           AcX=ReadWordAt(0x3B);  //Gyro X
           AcY=ReadWordAt(0x3D);
           AcZ=ReadWordAt(0x3F);
          TerText("  AcX= "); TerDec16S(AcX); 
          TerText("  AcY= "); TerDec16S(AcY);
          TerText("  AcZ= "); TerDec16S(AcZ); 
          TerCR(); 
          DelMs (500);
       }
      // reset to quit
    default: // blink wait return  ;
    break;
 } // end switch

} // end loop
  
